          DETAILED INPUT DESCRIPTION                                                                                                 
                                                                                                                                     
                                                                                                                                     
The input of all data is in free format. Numbers or symbols are separa-                                                              
ted by blanks, typed in any arbitrary column between columns 5 and 80.                                                               
The first four columns of the instruction data are provided for options                                                              
specifying the type of instruction. Any text in the first four columns                                                               
other than the options listed here will be ignored. Numbers can be given                                                             
as integers, floating point or floating comma numbers; all three types                                                               
will be transformed to floating point numbers. Atomic parameters may be                                                              
given in free format or fixed format as described below.                                                                             
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
a) instructions                                                                                                                      
                                                                                                                                     
The sequence of instructions is arbitrary except TITL and END which                                                                  
must be the first and last option, respectively, followed by the atom                                                                
parameters.                                                                                                                          
                                                                                                                                     
                                                                                                                                     
1. Heading, comment                                                                                                                  
                                                                                                                                     
   Option : TITL text                                                                                                                
                                                                                                                                     
   Up to 40 characters can be plotted as a heading. TITL must be the                                                                 
   first option, even if the text is left blank. Following lines,                                                                    
   starting with TITL are without action, but can be used as comments.                                                               
                                                                                                                                     
2. Output control                                                                                                                    
                                                                                                                                     
   In most cases this option can be omitted; the default parameters can                                                              
   be changed in BLOCK DATA if neccessary. Only if the output will be                                                                
   sent to different plotting devices (plotter, laser printer etc.)                                                                  
   parameter D has to be given in this option.                                                                                       
                                                                                                                                     
   Option : MODI D PA1 PA2  AR1  AR2  OR1 OR2                                                                                        
   Default: MODI 1  0   0  28.8 21.6   0   0                                                                                         
                                                                                                                                     
   - D defines the plotting device and is an integer which allows to                                                                 
     chose between different plotting devices as defined in subroutine                                                               
     DRAW by the user. D is not used in the STRUPLO version of June 86.                                                              
     This can be modified by the user in DRAW where D has the variable                                                               
     name ID.                                                                                                                        
   - PA1 PA2 are length and width of the paper; these parameters are                                                                 
     only needed for the PAGE call in the DISSPLA software.                                                                          
                                                                                                                                     
   - AR1 AR2 are length and width defining the plotting area. Dependent                                                              
     on these parameters the plot will be scaled;                                                                                    
                                                                                                                                     
   - OR1 OR2 are coordinates in cm (or inches) to shift the plot. This                                                               
     usually will cut off the plot, but might be desired in special                                                                  
     cases                                                                                                                           
                                                                                                                                     
                                                                                                                                     
3. Plot specification                                                                                                                
                                                                                                                                     
   Option : PARA A B C D E F G H                                                                                                     
   Default: PARA 1 1 1 1 1 1 1 3.2                                                                                                   
                                                                                                                                     
   A) Scale factor                                                                                                                   
                                                                                                                                     
      The plot is scaled to the full width of the paper, leaving a                                                                   
      margin for the heading. The width of the paper is defined in                                                                   
      AR1 and AR2 in BLOCK DATA, or as specified with option MODI.                                                                   
      Scale factors > 1 will cut off the drawing, but might be desired                                                               
      in special cases.                                                                                                              
                                                                                                                                     
   B) Index for center in origin                                                                                                     
                                                                                                                                     
      = 0 no center in the origin                                                                                                    
      = 1 centrosymmetric with center in the origin                                                                                  
                                                                                                                                     
   C) Index for outlines of unit cell                                                                                                
                                                                                                                                     
      = 0 no outlines                                                                                                                
      = 1 outlines are drawn                                                                                                         
                                                                                                                                     
        The present version of the program does not check overlaps of                                                                
        the outlines with polyhedra or spheres. It migght be necessary                                                               
        to draw the outlines of the parallelepiped by hand if the view                                                               
        direction is not parallel to one of the crystallographic unit                                                                
        vectors.                                                                                                                     
                                                                                                                                     
   D) Index for type of representation                                                                                               
                                                                                                                                     
      = 0 skeleton model                                                                                                             
                                                                                                                                     
        This representation, often used for framework structures, shows                                                              
        only the connections between the centers of neighboring                                                                      
        polyhedra.                                                                                                                   
                                                                                                                                     
      = 1 polyhedral representation                                                                                                  
                                                                                                                                     
        Tetrahedra and octahedra are sought by the program within the                                                                
        limits given in options TETR and OCTA. All polyhedra are hatched                                                             
        with equidistant lines parallel to that edge of the triangle                                                                 
        which is opposite  the vertex with the highest Z-coordinate.                                                                 
        In this way the density of hatching illustrates the inclination                                                              
        of a polyhedral face.                                                                                                        
                                                                                                                                     
   E) Index for tetrahedra                                                                                                           
                                                                                                                                     
      = 0 no tetrahedra                                                                                                              
                                                                                                                                     
      = 1 tetrahedra are sought and drawn within the values given in                                                                 
          option TETR. The default values correspond to average                                                                      
          Si-O distances.                                                                                                            
                                                                                                                                     
   F) Index for otahedra                                                                                                             
                                                                                                                                     
      = 0 no octahedra                                                                                                               
                                                                                                                                     
      = 1 octahedra are sought and drawn within the values given in                                                                  
          option OCTA. The default values correspond to average                                                                      
          (Na, Ca)-O distances.                                                                                                      
                                                                                                                                     
      If lines are drawn belonging  neither to tetrahedra nor octahedra                                                              
      the default parameters  have to be changed in option TETR or OCTA.                                                             
                                                                                                                                     
   G) Index for program execution                                                                                                    
                                                                                                                                     
      = 0 only tables with atomic coordinates and distances and angles                                                               
          are printed, no plot is produced.                                                                                          
                                                                                                                                     
      = 1 tables with atomic coordinates and distances  and angles are                                                               
          printed and a projection of the crystal structure is drawn.                                                                
                                                                                                                                     
   H) maximum value for interatomic distances to be calculated.                                                                      
      If more than 100 distances up to the value H are calculated the                                                                
      execution of the program will be terminated. In this case the                                                                  
      maximum distance should be given a lower value.                                                                                
                                                                                                                                     
                                                                                                                                     
4. Cell constants                                                                                                                    
                                                                                                                                     
   Option : CELL a  b  c   alpha beta  gamma                                                                                         
   Default: CELL 10 10 10   90    90    90                                                                                           
                                                                                                                                     
   The cell constants are expected in A and degrees.                                                                                 
                                                                                                                                     
                                                                                                                                     
5. Space group symbol                                                                                                                
                                                                                                                                     
   Option : SPGR space group symbol                                                                                                  
   Default: SPGR P1-                                                                                                                 
                                                                                                                                     
   Only the Bravais type is interpreted in this version of STRUPLO. The                                                              
   space group symbol does not replace the symmetry operators given in                                                               
   options SYMM. This will be included in a new version of the program.                                                              
                                                                                                                                     
                                                                                                                                     
6. Symmetry operators                                                                                                                
                                                                                                                                     
   Option : SYMM symmetry operators                                                                                                  
   Default: SYMM X,Y,Z                                                                                                               
                                                                                                                                     
   Each line beginning with SYMM contains several operators separated                                                                
   from each other by a semicolon. The last symbol in a line must not                                                                
   be a semicolon. Translations are given as fractions (1/2, 2/3 ...).                                                               
   The identity operator x,y,z and centrosymmetric counterparts are                                                                  
   not required. The syntax is consistent with the syntax in Internatio-                                                             
   nal Tables for Crystallography.                                                                                                   
                                                                                                                                     
7. Format for atomic parameters                                                                                                      
                                                                                                                                     
   Option : FORM A                                                                                                                   
   Default: FORM 4                                                                                                                   
                                                                                                                                     
   A format index; note that in all cases the atom name is read                                                                      
   in A2, I2.                                                                                                                        
                                                                                                                                     
   = 1 reads a SHELX parameter file (not instructions) including FVAR                                                                
       and interprets constraints. This part of the program has been                                                                 
       taken from the 1983 version of STRUPLO and could not be tested                                                                
       in the current form. Check carefully possible errors!                                                                         
                                                                                                                                     
   = 2 Format (2A1, I2, 26X, 3F10.6) corresponding to the input format                                                               
       of the atomic parameters in the least squares program ORFLS.                                                                  
                                                                                                                                     
   = 3 Format (2A1, I2, 3F10.6)                                                                                                      
                                                                                                                                     
   = 4 free format                                                                                                                   
       An atom name consisting of two letters is expected in the first                                                               
       two columns, followed by a sequence number and the X,Y,Z-                                                                     
       coordinates.                                                                                                                  
                                                                                                                                     
                                                                                                                                     
8. Rotation                                                                                                                          
                                                                                                                                     
   Option : ROTA A B C                                                                                                               
   Default: ROTA 0 0 0                                                                                                               
                                                                                                                                     
   A, B, C are rotation angles around the orthogonal axes X,Y,Z, with                                                                
   the origin in lower left corner, X pointing right, Y pointing up,                                                                 
   Z sticking out. The sense of rotation is shown in the following                                                                   
   graph.                                                                                                                            
                                                                                                                                     
             y                                                                                                                       
           |                                                                                                                         
           |                                                                                                                         
         <<<<<                                                                                                                       
           |                                                                                                                         
           |                                                                                                                         
           |                                                                                                                         
           |                                                                                                                         
         <<<<        V                                                                                                               
           z @_______V_______ x                                                                                                      
             @       V                                                                                                               
                     V                                                                                                               
                                                                                                                                     
            Z is parallel to the crystallographic c-axis,                                                                            
            Y is the trace of the crystallographic b-axis in the                                                                     
              plane perpendiculor to Z,                                                                                              
            X is parallel to Y x Z.                                                                                                  
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
9. View direction                                                                                                                    
                                                                                                                                     
   Option : VIEW X1 X2 X3  Y1 Y2 Y3                                                                                                  
   Default: VIEW 0  0  1   0  0  0                                                                                                   
                                                                                                                                     
   Instead of option ROTA, VIEW  can be used to specify a view direction                                                             
   X and Y are coordinate triples, where the vector defining the view                                                                
   direction  points from X to Y. If Y is not given, the origin 0,0,0                                                                
   is assumed. The space diagonal of a unit cell, for instance, would be                                                             
   defined by VIEW 1 1 1 .                                                                                                           
   This routine does not adjust one of the crystallographic axes paral-                                                              
   lel to the edge of the paper and the plot will have an arbitrary                                                                  
   orientation around the orthogonal Z-axis. This can be corrected by                                                                
   a subsequent run, where the rotation angles are taken from the output                                                             
   data on unit 6 as calculated by VIEW. Adding now a third rotation                                                                 
   angle in option ROTA and omitting VIEW will give a better orientation                                                             
                                                                                                                                     
                                                                                                                                     
10. Filecodes                                                                                                                        
                                                                                                                                     
   Option : FILE  A   B   C                                                                                                          
   Default: FILE  41  6   41                                                                                                         
                                                                                                                                     
   A input file for all instructions                                                                                                 
                                                                                                                                     
   B output file for coordinates, distance table                                                                                     
                                                                                                                                     
   C input file for atomic parameters                                                                                                
                                                                                                                                     
   Default values can be changed in BLOCK DATA for IO1, IO2, IO3.                                                                    
   Note that a change in parameter A only affects those instruction                                                                  
   lines which follow after FILE.                                                                                                    
                                                                                                                                     
                                                                                                                                     
11. Range in X,Y, and Z directions                                                                                                   
                                                                                                                                     
   Option : XYZR A1 A2 B1 B2 C1 C2   D1 D2 E1 E2 F1 F2                                                                               
   Default: calculated by program                                                                                                    
                                                                                                                                     
   All data given here refer to the unit vectors of the unit cell.                                                                   
   A1 A2, B1 B2, C1 C2 are minimum and maximum range (X,Y,Z) for                                                                     
   polyhedra, D1 D2, E1 E2, F1 F2 are the X,Y,Z components for the                                                                   
   range in which circles are to be drawn defined in CIRC. The range                                                                 
   for the circles must lie within the range for the polyhedra. If                                                                   
   only the range for the polyhedra is given, this range will be taken                                                               
   also for the circles.                                                                                                             
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
12. Circle specifications                                                                                                            
                                                                                                                                     
    Option : CIRC R N1 N2 N3....                                                                                                     
    Default: no circles                                                                                                              
                                                                                                                                     
    R      Radius  @A@                                                                                                               
                                                                                                                                     
    N1...  Atom names consisting of two letters corresponding to                                                                     
           the names of the atomic parameters                                                                                        
                                                                                                                                     
    'CIRC 0.8 NA CA' draws sodium and calcium atoms as circles                                                                       
    with radius 0.8 A. The symbols listed in one line refer                                                                          
    only to one radius which is always the first number in option CIRC.                                                              
    Up to 10 different radii (= 10 options CIRC) are accepted.                                                                       
    If circles appear not to be drawn completely, the value for the                                                                  
    resolution of the plotter is probably too high (see implementation                                                               
    instructions).                                                                                                                   
                                                                                                                                     
                                                                                                                                     
13. Tetrahedra specifications                                                                                                        
                                                                                                                                     
    Option : TETR   A   B   C    D                                                                                                   
    Default: TETR 109  20  1.62  0.2                                                                                                 
                                                                                                                                     
    A = tetrahedral angle                                                                                                            
    B = angle tolerance                                                                                                              
    C = mean distance from central atom to coordinated atoms                                                                         
    D = tolerance for C                                                                                                              
                                                                                                                                     
    Tetrahedra are sought and drawn with distances between central atom                                                              
    and vertices of C+-D @A@ and angles between central atom and two                                                                 
    vertices of A+-B @deg@.                                                                                                          
                                                                                                                                     
                                                                                                                                     
14. Octahedra specifications                                                                                                         
                                                                                                                                     
    Option : OCTA  A   B   C    D                                                                                                    
    Default: OCTA 90  20  1.97  0.4                                                                                                  
                                                                                                                                     
    The same meaning as in 10.                                                                                                       
                                                                                                                                     
                                                                                                                                     
15. Exclusion of atoms                                                                                                               
                                                                                                                                     
    Option : OMIT A B C D ...                                                                                                        
    Default: no atoms are excluded                                                                                                   
                                                                                                                                     
    A B C D ... refer to the numbers in parentheses in the output list                                                               
    on unit 6. If the numbers follow each other in direct sequence they                                                              
    may be given as A -B, where A and B are first and last number in                                                                 
    this sequence. With instruction 'OMIT 9 15 -18 23 26' atoms with                                                                 
    sequence number 9, 15, 16, 17, 18, 23, 26 are excluded from the                                                                  
    parameter list and will not be drawn. If an excluded atom belongs                                                                
    to a polyhedron the whole polyhedron will be omitted.                                                                            
                                                                                                                                     
16. Hatching polyhedra                                                                                                               
                                                                                                                                     
    Option : SHAD NL  N1 N2 N3 ...                                                                                                   
    Default: SHAD 9 1 -H(8)                                                                                                          
                                                                                                                                     
    With this option the number of lines NL for the hatching of a poly-                                                              
    hedral face can be chosen. If NL is negative all polyhedra are left                                                              
    blank. NL from 0 to 20 gives the number of lines per face of the                                                                 
    polyhedra N1 N2 N3 ... . These numbers refer to the sequence numbers                                                             
    of the polyhedra as given in the output list on unit 6. For explana-                                                             
    tion of the syntax see 15.                                                                                                       
                                                                                                                                     
                                                                                                                                     
17. End of instruction list                                                                                                          
                                                                                                                                     
    Option : END                                                                                                                     
    no default option                                                                                                                
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
                                                                                                                                     
b) atom parameters                                                                                                                   
                                                                                                                                     
                                                                                                                                     
   STRUPLO expects 5 statements per atom                                                                                             
                                                                                                                                     
   a) atom name, containing one or two letters                                                                                       
                                                                                                                                     
   b) atom label, any number < 100                                                                                                   
                                                                                                                                     
   c) fractional coordinates                                                                                                         
                                                                                                                                     
   only the coordinates in the asymmetric unit are required.                                                                         
                                                                                                                                     
